package org.apache.hadoop.mapred;

import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.jsp.*;
import java.io.*;
import java.util.*;
import org.apache.hadoop.mapred.*;
import org.apache.hadoop.util.*;
import javax.servlet.jsp.*;
import java.text.SimpleDateFormat;
import org.apache.hadoop.mapred.JobHistory.*;

public final class loadhistory_jsp extends org.apache.jasper.runtime.HttpJspBase
    implements org.apache.jasper.runtime.JspSourceDependent {

  private static java.util.Vector _jspx_dependants;

  public java.util.List getDependants() {
    return _jspx_dependants;
  }

  public void _jspService(HttpServletRequest request, HttpServletResponse response)
        throws java.io.IOException, ServletException {

    JspFactory _jspxFactory = null;
    PageContext pageContext = null;
    HttpSession session = null;
    ServletContext application = null;
    ServletConfig config = null;
    JspWriter out = null;
    Object page = this;
    JspWriter _jspx_out = null;
    PageContext _jspx_page_context = null;


    try {
      _jspxFactory = JspFactory.getDefaultFactory();
      response.setContentType("text/html; charset=UTF-8");
      pageContext = _jspxFactory.getPageContext(this, request, response,
      			null, true, 8192, true);
      _jspx_page_context = pageContext;
      application = pageContext.getServletContext();
      config = pageContext.getServletConfig();
      session = pageContext.getSession();
      out = pageContext.getOut();
      _jspx_out = out;

      out.write('\n');

	// Reload master index or a job file in session
	String reload = request.getParameter("reload"); 
	String jobid = request.getParameter("jobid"); 
	String jobTrackerId = request.getParameter("jobTrackerId"); 
	
	String jobLogDir = System.getProperty("hadoop.log.dir") + File.separator + "history" ; 
	
	String masterIndex = request.getParameter("historyFile"); ;
	
	if( null != masterIndex ) {
		String filePath = jobLogDir + File.separator + masterIndex ;
		File historyFile = new File(filePath); 
		if( null == request.getSession().getAttribute("jobHistory") || "true".equals(reload) ){
		  request.getSession().setAttribute("jobHistory", 
				DefaultJobHistoryParser.parseMasterIndex(historyFile)); 
		}
	}

	if( jobid != null && jobTrackerId != null ) {
	  
		JobHistory.JobInfo job = (JobHistory.JobInfo)request.getSession().getAttribute("job");
		if( null != job && (! jobid.equals(job.get(Keys.JOBID)) || 
		    ! jobTrackerId.equals(job.get(Keys.JOBTRACKERID)))){
		  // remove jobInfo from session, keep only one job in session at a time
		  request.getSession().removeAttribute("job"); 
		  job = null ; 
		}
		
		if( null == job ) {
  		  String jobLogFile = jobTrackerId + "_" + jobid; 
		  job = new JobHistory.JobInfo(jobid); 
		  job.set(Keys.JOBTRACKERID, jobTrackerId);
	      DefaultJobHistoryParser.parseJobTasks(
		  	    new File(jobLogDir + File.separator + jobLogFile), job) ; 
		  request.getSession().setAttribute("job", job); 
		}
	}

      out.write('\n');
    } catch (Throwable t) {
      if (!(t instanceof SkipPageException)){
        out = _jspx_out;
        if (out != null && out.getBufferSize() != 0)
          out.clearBuffer();
        if (_jspx_page_context != null) _jspx_page_context.handlePageException(t);
      }
    } finally {
      if (_jspxFactory != null) _jspxFactory.releasePageContext(_jspx_page_context);
    }
  }
}
