package org.apache.hadoop.mapred;

import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.jsp.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import org.apache.hadoop.mapred.*;
import org.apache.hadoop.util.*;
import java.text.SimpleDateFormat;
import org.apache.hadoop.mapred.JobHistory.*;

public final class taskdetailshistory_jsp extends org.apache.jasper.runtime.HttpJspBase
    implements org.apache.jasper.runtime.JspSourceDependent {

	private static SimpleDateFormat dateFormat = new SimpleDateFormat("d/MM HH:mm:ss") ; 

	private void printTaskAttempt(JobHistory.TaskAttempt taskAttempt, String type, JspWriter out) throws IOException{
  		out.print("<tr>"); 
  		out.print("<td>" + taskAttempt.get(Keys.TASK_ATTEMPT_ID) + "</td>");
         out.print("<td>" + StringUtils.getFormattedTimeWithDiff(dateFormat, taskAttempt.getLong(Keys.START_TIME), 0 ) + "</td>") ; 
  		if(Values.REDUCE.name().equals(type) ){
  		  JobHistory.ReduceAttempt reduceAttempt = (JobHistory.ReduceAttempt)taskAttempt ; 
	      out.print("<td>" + 
	          StringUtils.getFormattedTimeWithDiff(dateFormat, 
	              reduceAttempt.getLong(Keys.SHUFFLE_FINISHED), 
	              reduceAttempt.getLong(Keys.START_TIME)) + "</td>") ; 
	      out.print("<td>" + StringUtils.getFormattedTimeWithDiff(dateFormat, 
	          	 reduceAttempt.getLong(Keys.SORT_FINISHED), 
	          	 reduceAttempt.getLong(Keys.SHUFFLE_FINISHED)) + "</td>") ; 
  		}
	      out.print("<td>"+ StringUtils.getFormattedTimeWithDiff(dateFormat, taskAttempt.getLong(Keys.FINISH_TIME), 
					          taskAttempt.getLong(Keys.START_TIME) ) + "</td>") ; 
  		out.print("<td>" + taskAttempt.get(Keys.HOSTNAME) + "</td>");
  		out.print("<td>" + taskAttempt.get(Keys.ERROR) + "</td>");
  		out.print("</tr>"); 
	}

  private static java.util.Vector _jspx_dependants;

  public java.util.List getDependants() {
    return _jspx_dependants;
  }

  public void _jspService(HttpServletRequest request, HttpServletResponse response)
        throws java.io.IOException, ServletException {

    JspFactory _jspxFactory = null;
    PageContext pageContext = null;
    HttpSession session = null;
    ServletContext application = null;
    ServletConfig config = null;
    JspWriter out = null;
    Object page = this;
    JspWriter _jspx_out = null;
    PageContext _jspx_page_context = null;


    try {
      _jspxFactory = JspFactory.getDefaultFactory();
      response.setContentType("text/html; charset=UTF-8");
      pageContext = _jspxFactory.getPageContext(this, request, response,
      			null, true, 8192, true);
      _jspx_page_context = pageContext;
      application = pageContext.getServletContext();
      config = pageContext.getServletConfig();
      session = pageContext.getSession();
      out = pageContext.getOut();
      _jspx_out = out;

      out.write('\n');
      org.apache.jasper.runtime.JspRuntimeLibrary.include(request, response, "loadhistory.jsp" + (("loadhistory.jsp").indexOf('?')>0? '&': '?') + org.apache.jasper.runtime.JspRuntimeLibrary.URLEncode("jobid", request.getCharacterEncoding())+ "=" + org.apache.jasper.runtime.JspRuntimeLibrary.URLEncode(String.valueOf(request.getParameter("jobid") ), request.getCharacterEncoding()) + "&" + org.apache.jasper.runtime.JspRuntimeLibrary.URLEncode("jobTrackerId", request.getCharacterEncoding())+ "=" + org.apache.jasper.runtime.JspRuntimeLibrary.URLEncode(String.valueOf(request.getParameter("jobTrackerId") ), request.getCharacterEncoding()), out, false);
      out.write('\n');
      out.write('\n');
      out.write('\n');
	
	String jobid = request.getParameter("jobid");
	String jobTrackerId = request.getParameter("jobTrackerId");
	String taskid = request.getParameter("taskid"); 

	JobHistory.JobInfo job = (JobHistory.JobInfo)request.getSession().getAttribute("job");
	JobHistory.Task task = job.getAllTasks().get(taskid); 

      out.write("\n<html>\n<body>\n<h2>");
      out.print(taskid );
      out.write(" attempts for <a href=\"jobdetailshistory.jsp?jobid=");
      out.print(jobid);
      out.write("&&jobTrackerId=");
      out.print(jobTrackerId );
      out.write('"');
      out.write('>');
      out.write(' ');
      out.print(jobid );
      out.write(" </a></h2>\n<center>\n<table border=\"2\" cellpadding=\"5\" cellspacing=\"2\">\n<tr><td>Task Id</td><td>Start Time</td>\n");
	
	if( Values.REDUCE.name().equals(task.get(Keys.TASK_TYPE) ) ){

      out.write("\n\t\t<td>Shuffle Finished</td><td>Sort Finished</td>\n");

	}

      out.write("\n<td>Finish Time</td><td>Host</td><td>Error</td></tr>\n");

	for( JobHistory.TaskAttempt attempt : task.getTaskAttempts().values() ) {
	  printTaskAttempt(attempt, task.get(Keys.TASK_TYPE), out); 
	}

      out.write("\n</table>\n");
      out.write("\n</center>\n</body>\n</html>\n");
    } catch (Throwable t) {
      if (!(t instanceof SkipPageException)){
        out = _jspx_out;
        if (out != null && out.getBufferSize() != 0)
          out.clearBuffer();
        if (_jspx_page_context != null) _jspx_page_context.handlePageException(t);
      }
    } finally {
      if (_jspxFactory != null) _jspxFactory.releasePageContext(_jspx_page_context);
    }
  }
}
